/*
  * CelestialConstants.h
 *
 *  Created on: Mar 12, 2015
 *      Author: Joakim
 */

#ifndef CELESTIALCONSTANTS_H_
#define CELESTIALCONSTANTS_H_

#define G 8.883E-10 //Unit: days^-2 M_e^-1 AU^3
#define relaxationFactor 0.0

class CelestialConstants {
public:
	//Mass
	const static float sun_mass;
	const static float mercury_mass;
	const static float venus_mass;
	const static float earth_mass;
	const static float mars_mass;
	const static float jupiter_mass;
	const static float saturn_mass;
	const static float uranus_mass;
	const static float neptune_mass;
	const static float black_hole_mass;

	const static float black_hole_mass_actual;
	const static float black_hole_distance;
	const static float black_hole_distance_actual;

	//Orbit information
	const static float mercury_e;
	const static float venus_e;
	const static float earth_e;
	const static float mars_e;
	const static float jupiter_e;
	const static float saturn_e;
	const static float uranus_e;
	const static float neptune_e;

	const static float mercury_a;
	const static float venus_a;
	const static float earth_a;
	const static float mars_a;
	const static float jupiter_a;
	const static float saturn_a;
	const static float uranus_a;
	const static float neptune_a;

};

#endif /* CELESTIALCONSTANTS_H_ */
