/*
 * UserInput.h
 *
 *  Created on: Feb 18, 2015
 *      Author: Joakim
 */

#ifndef USERINPUT_H_
#define USERINPUT_H_

#include "CelestialTopology.h"
#include "../nbody/nbodyAlgorithm.h"
#include "../math/integration/IntegrationMethod.h"

class UserInput {
public:

	static float pauseSimulationAtTimestep;

	//Measure Time
	static bool measurePerformance;

	//Nbody Algorithm
	static NbodyAlgorithm nbodyAlgorithm;
	static NbodyAlgorithm fallbackAlgorithm;

	//Generator
	static float blackHoleClosestDistance;
	static float blackHoleMass;
	static int galaxyPlanes;
	static float galaxyPlanesDistance;

	//Integration Options
	static IntegrationMethod integrationMethod;
	static float celestialIntegrationRatio;

	static float distanceThreshold;
	static bool enableThresholdSwitching;

	//GPU Block Sizes
	static int allPairsBlockSize;
	static int celestialNbodyBlockSize;
	static int integrationBlockSize;

	//Screen Options
	static int res_height;
	static int res_width;

	//Miscellaneous Options
	static bool logSimulation;

	//Setter
	static bool setNbodyAlgorithm(NbodyAlgorithm nbodyAlgorithm);
	static void setBlackHoleMass(float starRatio);
	static bool setIntegrationMethod(IntegrationMethod integrationMethod);
	static bool setupSimulation(NbodyAlgorithm nbodyAlgorithm, IntegrationMethod integrationMethod);
	static void enableThreshold(float threshold);
	static void enableCelestialIntegration(float integrationRatio);
	static void resetToDefault();

};

#endif /* USERINPUT_H_ */
