#include "ValueComparison.h"
#include <stdio.h>
#include <stdlib.h>
#include <float.h>

float ValueComparison::compareArrayValues3f(float3 *a, float3* b, int N, bool verbose) {

	float diffTotal = 0;

	for (int i=0; i < N; i++) {

		if(verbose) {
			printAccelerationDifference3f(a[i],
					b[i], i);
		}

		float diff = differenceLength(a[i], b[i]);
		diffTotal += diff;
	}

	return diffTotal;

}

float ValueComparison::biggestDifference3f(float3 *a, float3* b, int N) {

	float biggestDiff;
	for (int i=0; i < N; i++) {

		biggestDiff = FLT_MIN;

		float diff = differenceLength(a[i], b[i]);

		biggestDiff = max(biggestDiff, diff);

	}

	return biggestDiff;


}

float ValueComparison::medianValue(float3 *a, float3* b, int N) {

    float *sortedAbsoluteValues = (float*) malloc(N * sizeof(float));

    for (int i = 0; i < N; ++i) {
    	sortedAbsoluteValues[i] = differenceLength(a[i], b[i]);
    }
    for (int i = N - 1; i > 0; --i) {
        for (int j = 0; j < i; ++j) {
            if (sortedAbsoluteValues[j] > sortedAbsoluteValues[j+1]) {
                float dTemp = sortedAbsoluteValues[j];
                sortedAbsoluteValues[j] = sortedAbsoluteValues[j+1];
                sortedAbsoluteValues[j+1] = dTemp;
            }
        }
    }

    // Middle or average of middle values in the sorted array.
    float median = 0.0;
    if ((N % 2) == 0) {
    	median = (sortedAbsoluteValues[N/2] + sortedAbsoluteValues[(N/2) - 1])/2.0;
    } else {
    	median = sortedAbsoluteValues[N/2];
    }

    free(sortedAbsoluteValues);

    return median;

}

float ValueComparison::differenceLength(float3 a, float3 b) {

	float3 diff = make_float3(a.x - b.x, a.y - b.y, a.z - b.z);

	return sqrt(diff.x * diff.x + diff.y * diff.y + diff.z * diff.z);

}

void ValueComparison::printAccelerationDifference3f(float3 a,
		float3 b, int index) {

	printf("Index: %d  X: %E %E \t Y: %E %E \t Z: %E %E Length: %E \n",index, a.x, b.x,
			a.y, b.y, a.z, b.z, differenceLength(a,b));

}
