/*
 * SimpleIntegration.h
 *
 *  Created on: May 27, 2015
 *      Author: Joakim
 */

#ifndef SIMPLEINTEGRATION_H_
#define SIMPLEINTEGRATION_H_

//As of Cuda 7.0, __global__ cannot be used with static methods, so we need to define them outside the
//class

//This is an explicit Euler Integration Method

__global__ void simpleIntegrationKernel(float3* acceleration, float3* acceleration_ext, float3* velocity, float3 *position, int N, float dt);

class CelestialSystem;

class SimpleIntegration {

public:

	//CPU
	static bool performIntegrationCPU(CelestialSystem* system, float dt);
	static void performSimpleIntegrationCPU(CelestialSystem* system, float3 *acceleration_ext, float dt);

	//GPU
	static bool performIntegrationGPU(CelestialSystem* system, float dt);

	//Special Integration scheme for the CelestialNbody Algorithm
	static bool performCelestialIntegrationCPU(CelestialSystem* system, float dt);
	static bool performCelestialIntegrationGPU(CelestialSystem* system, float dt);

};

#endif /* SIMPLEINTEGRATION_H_ */
