/*
 * SymplecticEuler.h
 *
 *  Created on: May 27, 2015
 *      Author: Joakim
 */

#ifndef SYMPLECTICEULER_H_
#define SYMPLECTICEULER_H_

__global__ void symplecticIntegrationKernel(float3* acceleration, float3 *acceleration_ext, float3* velocity, float3 *position, int N, float dt);

class CelestialSystem;

class SymplecticEuler {

public:

	//CPU
	static bool performIntegrationCPU(CelestialSystem* system, float dt);
	static void performSymplecticIntegrationCPU(CelestialSystem* system, float3 *acceleration_ext, float dt);

	//GPU
	static bool performIntegrationGPU(CelestialSystem* system, float dt);

	//Special Integration scheme for the CelestialNbody Algorithm
	static bool performCelestialIntegrationGPU(CelestialSystem* system, float dt);
	static bool performCelestialIntegrationCPU(CelestialSystem* system, float dt);

};

#endif /* SYMPLECTICEULER_H_ */
