/*
 * TransformationPipeline.h
 *
 *  Created on: Apr 3, 2015
 *      Author: Joakim
 */

#ifndef TRANSFORMATIONPIPELINE_H_
#define TRANSFORMATIONPIPELINE_H_

#include "CelestialStructs.h"

class TransformationPipeline {
public:
	void scale(float x, float y, float z);
	void rotate(float x, float y, float z);
	void translate(float x, float y, float z);
	void setPerspectiveValues(float width, float height, float FOV, float zNear, float zFar);
	void setOrthographicValues(float width, float height, float left, float right, float top, float bottom, float near, float far);
	TransformationPipeline()
	{
		scaleVector = PVector3f(1.0, 1.0, 1.0);
		translateVector = PVector3f(0.0, 0.0, 0.0);
		rotateVector = PVector3f(0.0, 0.0, 0.0);

	}
	const PMatrix4f* getTransformation(PVector3f cameraPos, PVector3f cameraTarget, PVector3f cameraUp);
private:
	PVector3f scaleVector;
	PVector3f translateVector;
	PVector3f rotateVector;
	PerspectiveValues perspectiveValues;
	OrthographicValues orthographicValues;
	PMatrix4f transformationMatrix; //The desired result matrix
};

#endif /* TRANSFORMATIONPIPELINE_H_ */
