/*
 * CelestialNbody.h
 *
 *  Created on: May 29, 2015
 *      Author: Joakim
 */

#ifndef CELESTIALNBODY_H_
#define CELESTIALNBODY_H_

//Define GPU Kernels

__global__ void calculateInternalAccelerationGPU(float3 *acceleration_d, float3 *position_d, float *mass_d, float4 *output_com, int N);

class CelestialNbody {

public:
	static bool launchCelestialNbodyKernel(float3 *acceleration_d, float3 *position_d, float *mass_d, int solarSystems, int solarBodies, bool enableThresholdSwitching);
	static bool celestialNbodyCPU(float3 *acceleration, float3 *position, float *mass, int solarSystems, int solarBodies, bool enableThresholdSwitching);
	static float4 *calculateInternalAccelerationCPU(float3 *acceleration, float3 *position, float *mass, int solarSystems, int solarBodies);
	static bool calculateExternalAccelerationCPU(float3 *acceleration, float3 *position, float *mass, float4 *massCenters,
			int solarSystems, int solarBodies, bool sumAcc, float distanceThreshold);
};

#endif /* CELESTIALNBODY_H_ */
