
//============================================
// include guard
#ifndef NBODY_ALLPAIRS_H_
#define NBODY_ALLPAIRS_H_
//============================================
//includes

#include "../utility/CudaErrorCheck.h"
#include "../input/UserInput.h"

//============================================

__device__ float3 compute_tile(float3 i_pos, float i_mass, float3 i_acc,
		int N, int threadID);
__global__ void perform_nbody_calculation(float3 *d_acceleration,
		float3 *d_position, float *d_mass, int N);

void nbody_allpairs_cpu(float3 *acceleration, float3 *position, float *mass,
		int N);
void nbody_allpairs_gpu(float3 *d_acceleration, float3 *d_position,
		float *d_mass, int N);

#endif //NBODY_ALLPAIRS_H_
