#include <stdio.h>
#include <stdlib.h>
#include "CudaMemory.h"

//Include other classes
#include "CudaErrorCheck.h"

void CudaMemory::printMemoryUsage() {

	size_t freeBytes, totalBytes;

	CudaSafeCall( cudaMemGetInfo(&freeBytes, &totalBytes));

	double freeBytesDouble = (double) freeBytes;
	double totalBytesDouble = (double) totalBytes;
	double usedBytesDouble = totalBytesDouble - freeBytesDouble;

	printf("GPU memory usage: used = %0.2f MB, free = %0.2f MB, total = %0.2f MB\n",
			usedBytesDouble/1024.0/1024.0, freeBytesDouble/1024.0/1024.0,
			totalBytesDouble/1024.0/1024.0);
}

void CudaMemory::printApplicationMemoryUsage(int N) {

	double usedBytes = 0.0;
	double usedSharedMemoryBytes = 0.0;

	//Position
	usedBytes += 3 * sizeof(float) * N;

	//Acceleration
	usedBytes += 3 * sizeof(float) * N;

	//Mass
	usedBytes += sizeof(float) * N;

	//Radius
	usedBytes += sizeof(float) * N;

	//Shared memory usage
	usedSharedMemoryBytes = 3 * sizeof(float) * N + sizeof(float) * N;

	printf("CelestialSystem memory usage: used = %0.2f Bytes\n",
			usedBytes);
	printf("GPU shared memory usage (per grid): used = %0.2f Bytes\n",
			usedSharedMemoryBytes);


}
