#include <cuda.h>
#include <cuda_runtime.h>
#include <stdio.h>

#include "CudaTimer.cuh"

/* Benchmarking functions */

void CudaTimer::cudaTimerStart() {

    cudaEventCreate(&timerStart);
    cudaEventCreate(&timerStop);

    cudaEventRecord(timerStart, 0);

}

float CudaTimer::cudaTimerStop() {

    cudaEventRecord(timerStop, 0);
    cudaEventSynchronize(timerStop);

    cudaEventElapsedTime(&elapsedTime, timerStart, timerStop);

    cudaEventDestroy(timerStart);
    cudaEventDestroy(timerStop);

    return elapsedTime;

}

void CudaTimer::printElapsedTime() {

	printf("[Simulation Output] GPU Elapsed Time: %f ms\n", elapsedTime);

}
