/*
 * Utilities.h
 *
 *  Created on: Mar 2, 2015
 *      Author: Joakim
 */

#ifndef UTILITIES_H_
#define UTILITIES_H_

#include "../nbody/nbodyAlgorithm.h"
#include "../math/integration/IntegrationMethod.h"
#include <string>

class Utilities {
public:
	static const char* readFile(const char* filepath);
	static std::string NbodyEnumToText(NbodyAlgorithm nbodyAlgorithm);
	static std::string IntegrationEnumToText(IntegrationMethod integrationMethod);
	static void printPythonArray(const char* varName, float *array, int N);
	static std::string createPythonArrayString(const char* varName, float *array, int N, int offset);
	static void runPythonPlotScript(float *x, float *y, int N, int offset, const char* xlabel, const char* ylabel, const char* title);
	static void runPython3DScatterPlot(float *x, float *y, float *z, int N);
	static double get_wtime();
	static void printElapsedTime(double before, double after);
};

#endif /* UTILITIES_H_ */
